/* 
 * File:   neopixel.h
 * Author: Lab User
 *
 * Created on November 16, 2017, 4:35 PM
 */

#ifndef NEOPIXEL_H
#define	NEOPIXEL_H
#include "plib.h"
typedef struct LEDPixel{
  char red;
  char green;
  char blue;
} pixel;
int numPixels=16;

//array of LED colors
pixel vector[16];
//39.7 nop=.10 us
//13.9 nop =.35 us
//27.8 nop = .70 us
//31.8 nop = .8 us
//23.8 nop =.6 us
void zero(){
  mPORTASetBits(BIT_2);
  asm("nop");asm("nop");asm("nop");asm("nop");asm("nop");asm("nop");
  asm("nop");asm("nop");asm("nop");asm("nop");asm("nop");asm("nop");
  
  mPORTAClearBits(BIT_2);
  asm("nop");asm("nop");asm("nop");asm("nop");asm("nop");asm("nop");
  asm("nop");asm("nop");asm("nop");asm("nop");asm("nop");asm("nop");
  asm("nop");asm("nop");asm("nop");asm("nop");asm("nop");asm("nop");
  asm("nop");asm("nop");asm("nop");
   
}
void one(){
  mPORTASetBits(BIT_2);
  asm("nop");asm("nop");asm("nop");asm("nop");asm("nop");asm("nop");
  asm("nop");asm("nop");asm("nop");asm("nop");asm("nop");asm("nop");
  asm("nop");asm("nop");asm("nop");asm("nop");asm("nop");asm("nop");
  asm("nop");asm("nop");asm("nop");asm("nop");asm("nop");asm("nop");
  asm("nop");asm("nop");
  
  mPORTAClearBits(BIT_2);
  asm("nop");asm("nop");asm("nop");asm("nop");asm("nop");asm("nop");
  asm("nop");asm("nop");asm("nop");asm("nop");asm("nop");asm("nop");
}

void delayT() {
  int x;
  for(x=0;x<2857100;x++);
  {
    asm("nop");asm("nop");asm("nop");asm("nop");asm("nop");asm("nop");
    asm("nop");asm("nop");asm("nop");asm("nop");asm("nop");asm("nop");         
  }
}

void delayS() {
  int x;
  for(x=0;x<285714;x++);
  {
    asm("nop");asm("nop");asm("nop");asm("nop");asm("nop");asm("nop");
    asm("nop");asm("nop");asm("nop");asm("nop");asm("nop");asm("nop");
  }
}

void delaySS() {
  int x;
  for(x=0;x<285700;x++);
  {
    asm("nop");asm("nop");asm("nop");asm("nop");asm("nop");asm("nop");
    asm("nop");asm("nop");asm("nop");asm("nop");asm("nop");asm("nop");       
  }
}

void init_pixels()
{
  mPORTASetPinsDigitalOut(BIT_2); 			
}

// set pixel p with color RGB
void setPixel(int p, char r, char g, char b)
{
  vector[p].red = r;
  vector[p].blue = b; 
  vector[p].green = g; 
}

// set pixel p with color C (integer RGB)
void setPixelC(int p, int c)
{
  vector[p].red = (char)((c >> 16) );
  vector[p].green = (char)((c >> 8));
  vector[p].blue = (char)(c );
}

// return int representing rgb color passed in
int color(unsigned int r, unsigned int g, unsigned int b)
{
  return ((int)r << 16) | ((int)g << 8) | b;
}

// display all of vecotr(LED array) on neopixel ring
void display()
{
  int x;
  delaySS();
  int currentBit;
  int red;
  int blue;
  int green;
    
  // iterate through all pixels (LED's) in vector
  for(x=0;x<numPixels;x++)	
  {
    // load in color of current pixel (LED)
	red=vector[x].red;
	blue=vector[x].blue;
	green=vector[x].green;
	
	// write out colors in GRB order for each green bit
	for(currentBit=0;currentBit<8;currentBit++)
	{
	  // if bit one, write one, if bit zero write zero (writes in assembly)
	  if((green&1))
		one();
	  else 
		zero();
		// shift in next green bit
    	green=green>>1;
	}
    
    // for each red bit
    for(currentBit=0;currentBit<8;currentBit++)
    {
        // if bit one, write one, if bit zero write zero (writes in assembly)
        if((red&1))
            one();
        else 
            zero();
        // shift in next red bit
        red=red>>1;
    }
    
    // for each blue bit
    for(currentBit=0;currentBit<8;currentBit++)
    {
        // if bit one, write one, if bit zero write zero (writes in assembly)
        if((blue&1))
            one();
        else 
            zero();
        // shift in next blue bit
        blue=blue>>1;
    }	
  }	
}

// clear all pixel values in vector (set to 0)
void clearPixels()
{
  int x;
  for(x=0;x<numPixels;x++)
  {
	vector[x].red=0;
	vector[x].blue=0;
	vector[x].green=0;
  }
}

// write white to all pixels
void white()
{
  int x;
  for(x=0;x<numPixels;x++)
  {
	vector[x].red=255;
	vector[x].blue=255;
	vector[x].green=255;
  }
}

// write red to all pixels
void red()
{
  int x;
  for(x=0;x<numPixels;x++)
  {
	vector[x].red=255;
	vector[x].blue=0;
	vector[x].green=0;
  }
}

// write green too all pixels
void green()
{
  int x;
  
  for(x=0;x<numPixels;x++)
  {
	vector[x].red=0;
	vector[x].blue=0;
	vector[x].green=255;
  }
}

// write blue to all pixels
void blue()
{
  int x;
  for(x=0;x<numPixels;x++)
  {
	vector[x].red=0;
	vector[x].blue=255;
	vector[x].green=0;
  }
}

void color_all(char r, char g, char b)
{
  int x;
  for(x=0;x<numPixels;x++)
  { 
	vector[x].red=r;
	vector[x].blue=g;
	vector[x].green=b;
  }
}

// sweep RGB color across all LED's
void colorWipe(char r, char g, char b) 
{
  int i;
  for(i=0; i<numPixels; i++) 
  {
    setPixel(i, r,g,b);
    display();
    delayT();
  }
}

// sweep RGB color across all LED's
void colorWipeF(char r, char g, char b) 
{
  int i;
  for(i=0; i<numPixels; i++) 
  {
    setPixel(i, r,g,b);
    display();
    delaySS();
  }
}

//Chase LED's (like in old time movie signs)
void theaterChase(char r, char g, char b) 
{
  int j;
  int q;
  int i;
  for (j=0; j<10; j++) 
  {
    for (q=0; q < 3; q++) 
    {
      for (i=0; i < numPixels; i=i+3) 
      {
		setPixel(i+q, r,g,b);     // turn every third pixel on
      }
      display();
      delayS();
      for (i=0; i < numPixels; i=i+3) 
      {
        setPixel(i+q, 0,0,0);     // turn every third pixel off
      }
    }
  }
}

// calculate color based on position of LED in circle
int Wheel(char WheelPos) 
{
  int toRet;
  WheelPos = 255 - WheelPos;
  if(WheelPos < 85) 
  {
	toRet=color(255 - WheelPos * 3, 0, WheelPos * 3);;
    return toRet;
  }
  if(WheelPos < (char)170) 
  {
    WheelPos -= 85;
	toRet=color(0, WheelPos * 3, 255 - WheelPos * 3);
    return toRet;
  }
  WheelPos -= 170;
  toRet=color(WheelPos * 3, 255 - WheelPos * 3, 0);
  return toRet;
}
//Show rainbow colors on LED's
void rainbow() 
{
  int i, j;
  for(j=0; j<256; j++) 
  {
    for(i=0; i<numPixels; i++) 
    {
      setPixelC(i, Wheel((i+j) & 255));
    }	
    for(i=0;i<10000;i++) 
    {
	  display();
    }
  }
}

//have rainbow colors spinning
void rainbowCycle() 
{
  int i, j;
  for(j=0; j<256*5; j++) 
  { 
    // 5 cycles of all colors on wheel
    for(i=0; i< numPixels; i++) 
    {
      setPixelC(i, Wheel(((i * 256 / numPixels) + j) & 255));
    }
    display();
	for(i=0;i<10000;i++);
  }
}

//have rainbow colors do theater chase
void theaterChaseRainbow() 
{
  int j,q,i;
  for ( j=0; j < 256; j++) {     // cycle all 256 colors in the wheel
    for ( q=0; q < 3; q++) {
      for ( i=0; i < numPixels; i=i+3) {
        setPixelC(i+q, Wheel( (i+j) % 255));    //turn every third pixel on
      }
      display();

      delayS();
      delayS();

      for (i=0; i < numPixels; i=i+3) {
        setPixelC(i+q, 0);        //turn every third pixel off
      }
    }
  }
}

#endif
